"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var React = __importStar(require("react"));
var useSyncStore = function (subscribe, getSnapshot, getServerSnapshot) {
    var getIsomorphicSnapshot = typeof document !== "undefined"
        ? getSnapshot
        : getServerSnapshot !== null && getServerSnapshot !== void 0 ? getServerSnapshot : getSnapshot;
    var _a = React.useState(getIsomorphicSnapshot()), state = _a[0], setState = _a[1];
    var onStoreChange = React.useCallback(function () { return setState(getIsomorphicSnapshot()); }, [getIsomorphicSnapshot]);
    React.useEffect(function () { return subscribe(onStoreChange); }, [subscribe, onStoreChange]);
    return state;
};
/* eslint-disable */
var useSafeSyncStore = 
// We use `toString()` to prevent bundlers from trying to `import { useSyncExternalStore } from "react"`
(_a = React["useSyncExternalStore".toString()]) !== null && _a !== void 0 ? _a : useSyncStore;
/* eslint-enable */
var createStoreContext = function (initialState) {
    var StateStoreContext = React.createContext(null);
    var usePubSub = function () {
        var store = React.useRef(initialState);
        var subscribers = React.useRef(new Set());
        var getState = React.useCallback(function () { return store.current; }, []);
        var setState = React.useCallback(function (setter) {
            var newState = typeof setter === "function"
                ? setter(store.current)
                : setter;
            store.current = newState;
            subscribers.current.forEach(function (cb) { return cb(); });
        }, []);
        var subscribe = React.useCallback(function (onStoreChange) {
            subscribers.current.add(onStoreChange);
            return function () {
                subscribers.current.delete(onStoreChange);
            };
        }, []);
        return React.useMemo(function () { return ({ getState: getState, setState: setState, subscribe: subscribe }); }, [getState, setState, subscribe]);
    };
    var Provider = function (props) {
        var pubSub = usePubSub();
        return ((0, jsx_runtime_1.jsx)(StateStoreContext.Provider, __assign({ value: pubSub }, { children: props.children }), void 0));
    };
    var useStore = function (selector) {
        var storeContext = React.useContext(StateStoreContext);
        if (!storeContext) {
            throw new Error("[@utilityjs/create-store-context]: You can only use `useStore` in a subtree of `<StoreProvider>`.");
        }
        var safeSelector = React.useMemo(function () { return selector !== null && selector !== void 0 ? selector : (function (state) { return state; }); }, [selector]);
        var getSnapshot = React.useCallback(function () { return safeSelector(storeContext.getState()); }, [safeSelector, storeContext]);
        var state = useSafeSyncStore(storeContext.subscribe, getSnapshot, getSnapshot);
        return [state, storeContext.setState];
    };
    return { useStore: useStore, StoreProvider: Provider };
};
exports.default = createStoreContext;
