var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var _a;
import { jsx as _jsx } from "react/jsx-runtime";
import * as React from "react";
var useSyncStore = function (subscribe, getSnapshot, getServerSnapshot) {
    var getIsomorphicSnapshot = typeof document !== "undefined"
        ? getSnapshot
        : getServerSnapshot !== null && getServerSnapshot !== void 0 ? getServerSnapshot : getSnapshot;
    var _a = React.useState(getIsomorphicSnapshot()), state = _a[0], setState = _a[1];
    var onStoreChange = React.useCallback(function () { return setState(getIsomorphicSnapshot()); }, [getIsomorphicSnapshot]);
    React.useEffect(function () { return subscribe(onStoreChange); }, [subscribe, onStoreChange]);
    return state;
};
/* eslint-disable */
var useSafeSyncStore = 
// We use `toString()` to prevent bundlers from trying to `import { useSyncExternalStore } from "react"`
(_a = React["useSyncExternalStore".toString()]) !== null && _a !== void 0 ? _a : useSyncStore;
/* eslint-enable */
var createStoreContext = function (initialState) {
    var StateStoreContext = React.createContext(null);
    var usePubSub = function () {
        var store = React.useRef(initialState);
        var subscribers = React.useRef(new Set());
        var getState = React.useCallback(function () { return store.current; }, []);
        var setState = React.useCallback(function (setter) {
            var newState = typeof setter === "function"
                ? setter(store.current)
                : setter;
            store.current = newState;
            subscribers.current.forEach(function (cb) { return cb(); });
        }, []);
        var subscribe = React.useCallback(function (onStoreChange) {
            subscribers.current.add(onStoreChange);
            return function () {
                subscribers.current.delete(onStoreChange);
            };
        }, []);
        return React.useMemo(function () { return ({ getState: getState, setState: setState, subscribe: subscribe }); }, [getState, setState, subscribe]);
    };
    var Provider = function (props) {
        var pubSub = usePubSub();
        return (_jsx(StateStoreContext.Provider, __assign({ value: pubSub }, { children: props.children }), void 0));
    };
    var useStore = function (selector) {
        var storeContext = React.useContext(StateStoreContext);
        if (!storeContext) {
            throw new Error("[@utilityjs/create-store-context]: You can only use `useStore` in a subtree of `<StoreProvider>`.");
        }
        var safeSelector = React.useMemo(function () { return selector !== null && selector !== void 0 ? selector : (function (state) { return state; }); }, [selector]);
        var getSnapshot = React.useCallback(function () { return safeSelector(storeContext.getState()); }, [safeSelector, storeContext]);
        var state = useSafeSyncStore(storeContext.subscribe, getSnapshot, getSnapshot);
        return [state, storeContext.setState];
    };
    return { useStore: useStore, StoreProvider: Provider };
};
export default createStoreContext;
